#coding=utf-8

"""
Programadores:

"""

"""
Carlos J Corrada Bravo
Este programa calcula el promedio de tiempo de ejecución de cuatro algoritmos de ordenamiento
La variable maxValor define el valor maximo de los elementos de la lista
La variable largoLista define el largo de las listas a ordenar
La variable veces define las veces que se va a hacer el ordenamiento
Al final se imprimen los promedios de cada algortimo
"""

from random import randint
import time

def mergeSort(listaMerge):
	#definan el algoritmo de ordenamiento mergesort

	return lista

#===============================
#Modificación a código: Diego
#Añado función heapify
#===============================
def heapify(listaHeap, largoLista, i):
	largest = i
	left = 2 * i + 1
	right = 2 * i + 2

	if left < largoLista and listaHeap[i] < listaHeap[left]:
		largest = left

	if right < largoLista and listaHeap[largest] < listaHeap[right]:
		largest = right

	if largest != i:
		listaHeap[i], listaHeap[largest] = listaHeap[largest], listaHeap[i]
		heapify(listaHeap, largoLista, largest)
#Fin de función heapify
#===============================

def heapSort(listaHeap):
	#definan el algoritmo de ordenamiento heapsort

	for i in range(len(listaHeap) / 2, -1, -1):
		heapify(listaHeap, len(listaHeap), i)

	for i in range(len(listaHeap) - 1, 0, -1):
		listaHeap[i], listaHeap[0] = listaHeap[0], listaHeap[i]
		heapify(listaHeap, i, 0)
	return listaHeap

def quickSort(lista):
	#definan el algoritmo de ordenamiento quicksort
	return lista

def shellSort(lista):
	#definan el algoritmo de ordenamiento shellsort
	return lista

maxValor=1000 	#define el valor maximo de los elementos de la lista
largoLista=1000 #define el largo de las listas a ordenar
veces=100 		#define las veces que se va a hacer el ordenamiento

acumulaMerge=0 	#variable para acumular el tiempo de ejecucion del mergesort
acumulaHeap=0 	#variable para acumular el tiempo de ejecucion del heapsort
acumulaQuick=0 	#variable para acumular el tiempo de ejecucion del quicksort
acumulaShell=0 	#variable para acumular el tiempo de ejecucion del shellsort

for i in range(veces):
	#Creamos una lista con valores al azar
	lista = [randint(0,maxValor) for r in range(largoLista)]

	listaMerge = lista[:]
	listaHeap = lista[:]
	listaQuick = lista[:]
	listaShell = lista[:]

	t1 = time.clock() 				#seteamos el tiempo al empezar
	mergeSort(listaMerge) 			#ejecutamos el algoritmo mergeSort
	acumulaMerge+=time.clock()-t1 	#acumulamos el tiempo de ejecucion

	t1 = time.clock()				#seteamos el tiempo al empezar
	heapSort(listaHeap)				#ejecutamos el algoritmo heapSort
	acumulaHeap+=time.clock()-t1 	#acumulamos el tiempo de ejecucion

	t1 = time.clock()				#seteamos el tiempo al empezar
	quickSort(listaQuick)			#ejecutamos el algoritmo quickSort
	acumulaQuick+=time.clock()-t1 	#acumulamos el tiempo de ejecucion

	t1 = time.clock()				#seteamos el tiempo al empezar
	shellSort(listaShell)			#ejecutamos el algoritmo shellSort
	acumulaShell+=time.clock()-t1 	#acumulamos el tiempo de ejecucion

#imprimos los resultados
print "Promedio de tiempo de ejecucion de "+ str(veces) +" listas de largo " + str(largoLista)
print "MergeSort " + str(acumulaMerge/veces) + " segundos"
print "HeapSort " + str(acumulaHeap/veces) + " segundos"
print "QuickSort " + str(acumulaQuick/veces) + " segundos"
print "ShellSort " + str(acumulaShell/veces) + " segundos"
